#include <iostream.h>
#include <fcntl.h>
#include <ctype.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

#define LINE_LEN_MAX    128                  // actual max line length
#define BUFFERSIZE      LINE_LEN_MAX +2      // ... including \n and \0

typedef struct {
	bool usemidi;
   bool usewav;
   bool usecd;
   bool useds;
   bool usetimer;
   int  cdtrack;
   int  mspf;
   int  bpp;
} config_info;

typedef struct {
   char * name ;
   char * data ;
} CfgStrings;

enum RetVal{
    NO_PROBLEMS,
    ERR_FOPEN,
    ERR_MEM,
};

const int BUFFER_SIZE = (1);
int  LevelLength;
int  in_file;
char buffer[BUFFER_SIZE];
long read_size;
config_info config;
CfgStrings CfgData[9] = {
	{ "directsound" , NULL },
	{ "midimusic"   , NULL },
   { "cdmusic"     , NULL },
   { "wavemusic"   , NULL },
   { "cdtrack"     , NULL },
   { "pixeldepth"  , NULL },
   { "usetimer"    , NULL },
   { "targetmspf"  , NULL },
   { NULL          , NULL }         /* array terminator. REQUIRED !!! */
};

bool Load_Level(int level);
bool Load_Level_Data(void);
int  CfgRead( char * Filename, CfgStrings * CfgInfo );
bool Load_Config(void);
int  GetInt(char *str);
bool GetBool(char *str);
int GetNumberofLevels(void);

int GetNumberofLevels(void)
{

int NumLevels = 0;

	in_file = open("levels.dat", O_RDONLY | O_TEXT);
	if (in_file < 0) return NumLevels;
	while (1) {
		read_size = read(in_file, buffer, BUFFER_SIZE);
		if (read_size == 0) break;                    //End of file
      if (read_size < 0) return NumLevels;
		switch (buffer[0]) {
			case '!':
      		++NumLevels;
         	break;
      	default:
      		break;
      	}
   	}
   return NumLevels-1;
}

bool Load_Level(int level)
{

if (level>2) return false;
in_file = open("levels.dat", O_RDONLY | O_TEXT);
if (in_file < 0) return false;
while (1) {
	read_size = read(in_file, buffer, BUFFER_SIZE);
	if (read_size == 0) break;                    //End of file
	if (read_size < 0) return false;
	switch (buffer[0]) {
		case '!':
			read_size = read(in_file, buffer, BUFFER_SIZE);
			if (read_size == 0) break;                    //End of file
			if (read_size < 0) return false;
        	if (level==atoi(buffer)) {
         	while (1) {
            	read_size = read(in_file, buffer, BUFFER_SIZE);
               if (read_size == 0) break;                    //End of file
               if (read_size < 0) return false;
               switch (buffer[0]) {
                  case '\n':
                     return Load_Level_Data();
                  default :
                     break;
                  }
               }
            }
         break;
      default :
         break;
      }
   }
return false;
}

bool Load_Level_Data(void)
{

int  i=0, o=0, number;

while (o<15) {
   read_size = read(in_file, buffer, BUFFER_SIZE);
   if (read_size == 0) break;                    //End of file
   if (read_size < 0) return false;
   switch(buffer[0]) {
      case '0':
         dungeon1[o][i] = 0;
         ++i;
         break;
      case '1':
         dungeon1[o][i] = 1;
         ++i;
         break;
      case '2':
         dungeon1[o][i] = 2;
         ++i;
         break;
      case '3':
         dungeon1[o][i] = 3;
         ++i;
         break;
      case '4':
         dungeon1[o][i] = 4;
         ++i;
         break;
      case '5':
         dungeon1[o][i] = 5;
         ++i;
         break;
      case '6':
         dungeon1[o][i] = 6;
         ++i;
         break;
      case '7':
         dungeon1[o][i] = 7;
         ++i;
         break;
      case '8':
         dungeon1[o][i] = 8;
         ++i;
         break;
      case '9':
         dungeon1[o][i] = 9;
         ++i;
         break;
      case 'a':
         dungeon1[o][i] = 10;
         ++i;
         break;
      case 'b':
         dungeon1[o][i] = 11;
         ++i;
         break;
      case '\n':
         ++o;
         LevelLength=i-21;
         i=0;
         break;
      }
   }
i=0;
o=0;
while (o<15) {
   read_size = read(in_file, buffer, BUFFER_SIZE);
   if (read_size == 0) break;                    //End of file
   if (read_size < 0) return false;
   switch(buffer[0]) {
      case '0':
      	++i;
         break;
      case '1':
      	number=0;
      	while(number<100) {
         	if (!monsters[number].active) {
         		monsters[number].active=true;
         		monsters[number].y=32*o;
            	monsters[number].x=i*32;
            	monsters[number].direction=0;
        			monsters[number].hp=4;
   				monsters[number].animnum=0;
      			monsters[number].engaged=false;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '2':
      	number=0;
      	while(number<100) {
         	if (!monsters[number].active) {
         		monsters[number].active=true;
         		monsters[number].y=32*o;
            	monsters[number].x=i*32;
            	monsters[number].direction=1;
        			monsters[number].hp=4;
   				monsters[number].animnum=0;
      			monsters[number].engaged=false;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '\n':
         ++o;
         i=0;
         break;
      default:
      	break;
      }
   }
i=0;
o=0;
while (o<15) {
   read_size = read(in_file, buffer, BUFFER_SIZE);
   if (read_size == 0) break;                    //End of file
   if (read_size < 0) return false;
   switch(buffer[0]) {
      case '0':
      	++i;
         break;
      case '1':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
            	pickups[number].type=0;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '2':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
               pickups[number].type=1;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '3':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
               pickups[number].type=2;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '4':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
               pickups[number].type=3;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '5':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
               pickups[number].type=4;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '6':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
               pickups[number].type=5;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '7':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
               pickups[number].type=6;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '8':
      	number=0;
      	while(number<100) {
         	if (!pickups[number].active) {
         		pickups[number].active=true;
         		pickups[number].y=32*o;
            	pickups[number].x=i*32;
               pickups[number].type=7;
            	break;
            	}
         	else number++;
         	}
         ++i;
         break;
      case '\n':
         ++o;
         i=0;
         break;
      default:
      	break;
      }
   }
close(in_file);
return true;
}

int CfgRead( char * Filename, CfgStrings * CfgInfo )
{

char Buffer[ BUFFERSIZE ];
char * WorkPtr ;
char * CfgName ;
char * CfgData ;
CfgStrings * Cfg ;
FILE * CfgFile ;

   CfgFile = fopen( Filename, "r" );
   if( NULL == CfgFile ) return ERR_FOPEN ;
   while( NULL != fgets( Buffer, BUFFERSIZE, CfgFile )) {
      // clip off optional comment tail indicated by a semi-colon
      if( NULL != (WorkPtr = strchr( Buffer, ';' ))) *WorkPtr = '\0';
      else WorkPtr = Buffer + strlen( Buffer );
      // clip off trailing and leading white space
      WorkPtr--;
      while( isspace( *WorkPtr ) && WorkPtr >= Buffer ) *WorkPtr-- = '\0';
      WorkPtr = Buffer;
      while( isspace( *WorkPtr )) WorkPtr++;
      if( 0 == strlen( WorkPtr )) continue;
      CfgName = strtok( WorkPtr, " =" );
      if( NULL != CfgName ) {
      // Condition the name (lower case required),and strip leading white and a 'late' = from data part.
      strlwr( CfgName );
      CfgData = strtok( NULL, "" );
      while( isspace( *CfgData )) CfgData++;
      if( '=' == *CfgData ) CfgData++;
      while( isspace( *CfgData )) CfgData++;
      // look for matching 'name'
      Cfg = CfgInfo ;
      while( NULL != Cfg->name && 0 != strcmp( Cfg->name, CfgName )) Cfg++;
      // duplicate the data if the name is found.
      if( NULL != Cfg->name ) {
         Cfg->data = strdup( CfgData ); // strdup is not ANSI memory leaks if Cfg->data is malloc'ed already
         if( NULL == Cfg->data ) {
            fclose( CfgFile );
            return ERR_MEM;
            }
         }   // undetected error on failure should not be a problem as configuration reading should be done early. but test and handle it anyway ...
      }
   }
   fclose( CfgFile );
   return NO_PROBLEMS ;
}

bool Load_Config(void)
{

   if (CfgRead( "mraks.ini", CfgData )!=NO_PROBLEMS) return false;
   config.useds=GetBool(CfgData[0].data);
   config.usemidi=GetBool(CfgData[1].data);
   config.usecd=GetBool(CfgData[2].data);
   config.usewav=GetBool(CfgData[3].data);
   config.cdtrack=GetInt(CfgData[4].data);
   config.bpp=GetInt(CfgData[5].data);
   if ((config.bpp!=8)&&(config.bpp!=16)&&(config.bpp!=24)&&(config.bpp!=32)) config.bpp=8;
   config.usetimer=GetBool(CfgData[6].data);
   config.mspf=GetInt(CfgData[7].data);
   if ((config.mspf<1) || (config.mspf>1000)) config.mspf=25;
   return true;
}

int GetInt(char *str)
{

   return atoi(str);
}

bool GetBool(char *str)
{

	if ((strcmp(str,"true")==0) || (strcmp(str,"True")==0) || (strcmp(str,"TRUE")==0)) return true;
	else if ((strcmp(str,"false")==0) || (strcmp(str,"False")==0) || (strcmp(str,"FALSE")==0)) return false;
   return false;
}
