/////////************DEFINES*************//////////
#if defined( __BORLANDC__ ) && defined( __WIN32__ )
#define _WIN32
#endif

#define NAME "MRAKS"
#define TITLE "Mindlessly Running Around Killing Stuff v0.1 BETA"

#define PlayerHurt   0
#define GunShot      1
#define SGunShot     2

#define Gun          0
#define ShotGun      1
#define MGun         2

#define HGun         201
#define SGun         202
#define OW           203

/////////*************MACROS*************//////////
#define KEY_DOWN(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)
#define KEY_UP(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 0 : 1)
#define USE_PARAM(x)    (x) = (x)

/////////************TYPEDEFS************//////////
typedef struct {
   int  hp;
   int  x;
   int  y;
   int  direction;
   int  animnum;
   int  jumpstate;
   int  lastshot;
   int  invonerablestate;
   int  currentweapon;
   int  currentlevel;
   bool jumping;
   bool active;
   bool invonerable;
} player_info;

typedef struct {
   int  hp;
   int  x;
   int  y;
   int  direction;
   int  animnum;
   int  jumpstate;
   bool jumping;
   bool active;
   bool engaged;
} monster_info;

typedef struct {
	int  x;
   int  y;
   int  type;
   bool active;
} pickup_info;

typedef struct {
	int  pausecycles;
   int  ammo;
   int  sound;
   int  damage;
   int  speed;
	bool active;
} weapon_info;

typedef struct {
   int  x;
   int  y;
   int  type;
   int  direction;
   bool active;
} bullet_info;

/////////************GLOBALS*************//////////
int tilex;                              // X position of the current tile.
int tiley;                              // Y position of the current tile.
int GameState = 1;                      // What state is the program in?
int xoff, yoff;                         // X, Y image offset.
int dungeon1[15][100];                  // Level Tiles.
int NumLevels;                          // Number of Levels.
char TILES[] = "IDB_BackGround_Tiles";  // Bitmap containing Tile Textures.
char PLAYER[] = "IDB_Player_Sprites";   // Bitmap containing Player Images.
char MONSTER[] = "IDB_Monster_Sprites"; // Bitmap containing Monster Images.
char STATUS[] = "IDB_Status_Sprites";   // Bitmap containing Status Images.
char PICKUP[] = "IDB_Pickup_Sprites";   // Bitmap containing Pickups Images.
char FONT[] = "IDB_Font";               // Bitmap containing The Font.
bool can_scroll_left;                   // Well can we?
bool can_scroll_right;                  // Well can we?
bool music_enabled;                     // Well is it?
bool DS_InitOK;                         // Did DirectSound Init OK?
player_info player;                     // Player Position and other stats.
bullet_info bullets[100];               // Bullets info.
monster_info monsters[100];             // Info for the monsters.
pickup_info pickups[100];               // Info on pickups.
weapon_info weapons[10];                // Info on our 10 weapons.
HWND main_window_handle = NULL;         // Used to store the window handle.
LPDIRECTDRAW            lpDD;           // DirectDraw object.
LPDIRECTDRAWSURFACE     lpDDSPrimary;   // DirectDraw primary surface.
LPDIRECTDRAWSURFACE     lpDDSBack;      // DirectDraw back surface.
LPDIRECTDRAWSURFACE     lpDDSTiles;     // Offscreen surface containing Tile Textures.
LPDIRECTDRAWSURFACE     lpDDSPlayer;    // Offscreen surface containing Player Images.
LPDIRECTDRAWSURFACE     lpDDSMonster;   // Offscreen surface containing Monster Images.
LPDIRECTDRAWSURFACE     lpDDSStatus;    // Offscreen surface containing Status Images.
LPDIRECTDRAWSURFACE     lpDDSPickups;   // Offscreen surface containing Pickups Images.
LPDIRECTDRAWSURFACE     lpDDSFont;      // Offscreen surface containing The Font.
LPDIRECTDRAWPALETTE     lpDDPal;        // DirectDraw palette.

/////////*******FUNCTION PROTOTYPES******//////////
HRESULT DD_RestoreAll(void);
void DD_Fini(void);
bool DD_InitFail(HWND hwnd);
void MoveMonsters(void);
void DrawText(int x, int y, char string[], int size);
void DrawTiles(int posx,int posy,int x1,int y1,int x2,int y2);
void DrawBackGround(void);
void DrawPlayer(void);
void DrawBullets(void);
void MoveBullets(void);
void DrawMonsters(void);
void DrawPickups(void);
void DetectPickups(void);
void DetectMisc(void);
void DrawStatus(void);
void GameInit(void);
void PlayerInit(void);
void Critical(void);
void FlipScreen(void);
void FiniObjects(void);
void TitleUpdateScreen(void);
void GameUpdateScreen(void);
void Open_Music(void);
void Start_Or_Restart_Track(void);
void Stop_Music(void);
void Close_Music(void);
